%define subrel 1
Name:    tigervnc
Version: 1.3.0
Release: %mkrel 2
License:   GPLv2+
URL:       http://www.tigervnc.com/
Source0:        %{name}-%{version}.tar.bz2
Source6:        vncviewer.desktop

#Patch mga3
Patch1:         tigervnc-cookie.patch
Patch2:         tigervnc11-ldnow.patch
Patch3:         tigervnc11-gethomedir.patch
Patch4:         tigervnc11-rh692048.patch
# Patch syncro fdr 20
Patch5:         tigervnc-fdr-inetd-nowait.patch
Patch6:         tigervnc-fdr-setcursor-crash.patch
Patch7:         tigervnc-fdr-manpages.patch
Patch8:         tigervnc-fdr-getmaster.patch
Patch9:         tigervnc-fdr-shebang.patch
# Patch from openmdv to build
Patch10:        tigervnc11-mdv-link.patch
Patch11:        tigervnc11-mdv-strfmt.patch
Patch12:        tigervnc11-mdv-buildir.patch
# Patch CVE-2014-0011
Patch13:        tigervnc-fdr-CVE-2014-0011.patch



BuildRequires:  x11-server-source
BuildRequires:  gettext-devel
BuildRequires:  pkgconfig(x11)
BuildRequires:  libxext-devel
BuildRequires:  x11-font-util
BuildRequires:  x11-util-macros
BuildRequires:  x11-xtrans-devel
BuildRequires:  mesagl-devel
BuildRequires:  libxkbfile-devel
BuildRequires:  libxfont-devel
BuildRequires:  pixman-devel
BuildRequires:  openssl-devel
BuildRequires:  libpciaccess-devel
BuildRequires:  libpam-devel
BuildRequires:  libxtst-devel
BuildRequires:  gnutls-devel
BuildRequires:  imagemagick
BuildRequires:  nasm
BuildRequires:  java-devel
BuildRequires:  desktop-file-utils
BuildRequires:  jpackage-utils
BuildRequires:  java-rpmbuild
BUildRequires:  fltk-devel
BuildRequires:  libtool
BuildRequires:  autoconf
BUildRequires:  libxi-devel
BuildRequires:  libxinerama-devel
BuildRequires:  freetype-devel
BuildRequires:  libxdmcp-devel
BuildRequires:  pam-devel
BuildRequires:  libjpeg-devel
BuildRequires:  cmake




#------------------------------------------------------------------------------

# package tigervnc

Summary: Viewer for the VNC remote display system
Group:   Networking/Remote access

%description
Virtual Network Computing (VNC) is a remote display system which
allows you to view a computing 'desktop' environment not only on the
machine where it is running, but from anywhere on the Internet and
from a wide variety of machine architectures.  This package contains a
client which will allow you to connect to other desktops running a VNC
server.

%files -f %{name}.lang
%_defaultdocdir/%{name}-%{version}/*
%{_bindir}/vncviewer
%{_iconsdir}/*
%{_datadir}/applications/*
%{_mandir}/man1/vncviewer.1*


#------------------------------------------------------------------------------

%package server

Summary: Server for the VNC remote display system
Group:   Networking/Remote access

Requires: vnc-server-common

%description server
The VNC system allows you to access the same desktop from a wide
variety of platforms.  This package is a TigerVNC server, allowing
others to access the desktop on your machine.

%files server
%{_bindir}/vncconfig
%{_bindir}/vncpasswd
%{_bindir}/x0vncserver
%{_bindir}/Xvnc
%{_bindir}/vncserver
%{_mandir}/man1/Xvnc.1*
%{_mandir}/man1/vncpasswd.1*
%{_mandir}/man1/vncconfig.1*
%{_mandir}/man1/vncserver.1*
%{_mandir}/man1/x0vncserver.1*

#------------------------------------------------------------------------------

%package server-module

Summary: Xorg module for the VNC remote display system
Group:   Networking/Remote access

Requires: x11-server-xorg

%description server-module
This package contains libvnc.so module to X server, allowing others
to access the desktop on your machine.

%files server-module
%{_libdir}/xorg/modules/extensions/libvnc.so

#------------------------------------------------------------------------------

%package java

Summary: Java viewer for the VNC remote display system
Group:   Networking/Remote access


# "TightVNC-specific" is not a typo, see the README file located inside the
# java source tree
%description java
This distribution is based on the standard VNC source and includes new
TightVNC-specific features and fixes, such as additional low-bandwidth
optimizations, major GUI improvements, and more.

There are three basic ways to use TigerVNC Java viewer:
  1. Running applet as part of TigerVNC server installation.
  2. Running applet hosted on a standalone Web server.
  3. Running the viewer as a standalone application.

%files java
%{_javadir}/*.jar
%{_datadir}/vnc

#------------------------------------------------------------------------------

%prep
%setup -q -n %{name}-%{version}

%patch12 -p1 -b .builddir
%patch1 -p1 -b .cookie
%patch2 -p1 -b .ldnow
%patch3 -p1 -b .gethomedir
%patch4 -p1 -b .rh692048
%patch11 -p1 -b .strfmt




cp -r /usr/share/x11-server-source/* unix/xserver
pushd unix/xserver
for all in `find . -type f -perm -001`; do
        chmod -x "$all"
done
patch -p1 -b --suffix .vnc < ../xserver114.patch

popd

# Applied Debian patch to fix busy loop when run from inetd in nowait
# mode (bug #920373).
%patch5 -p1 -b .inetd-nowait

%patch6 -p1 -b .setcursor-crash

# Synchronise manpages and --help output (bug #980870).
%patch7 -p1 -b .manpages

# libvnc.so: don't use unexported GetMaster function (bug #744881 again).
%patch8 -p1 -b .getmaster

# Don't use shebang in vncserver script.
%patch9 -p1 -b .shebang


%patch10 -p1 -b .link

# Fixed heap-based buffer overflow (CVE-2014-0011, mga #13082)
%patch13 -p1 -b .CVE-2014-0011


%build

%{cmake}
%make
cd ..

pushd unix/xserver
rm -f configure
autoreconf -fiv
%configure2_5x  --disable-xorg --disable-xnest --disable-xvfb --disable-dmx \
                --disable-xwin --disable-xephyr --disable-kdrive --with-pic \
                --disable-static --disable-xinerama \
                --with-default-font-path="catalogue:%{_sysconfdir}/X11/fontpath.d,built-ins" \
                --with-fontdir=%{_datadir}/X11/fonts \
                --with-xkb-output=%{_localstatedir}/lib/xkb \
                --enable-install-libxf86config \
                --enable-glx --disable-dri --enable-dri2 \
                --disable-config-dbus \
                --disable-config-hal \
                --disable-config-udev \
                --with-dri-driver-path=%{_libdir}/dri \
                --without-dtrace \
                --disable-unit-tests \
                --disable-devel-docs \
                --disable-selective-werror

%make

popd


# Build icons
pushd media
%{cmake}
%make

popd

# Build java
pushd java
%{cmake}
%make
#cd ..
popd

%install
rm -rf %{buildroot}
pushd build
%makeinstall_std
popd

pushd unix/xserver/hw/vnc
%makeinstall_std
popd

# Install desktop stuff
mkdir -p %{buildroot}/%{_datadir}/icons/hicolor/{16x16,24x24,48x48}/apps

pushd media/icons
for s in 16 24 48; do
install -m644 tigervnc_$s.png %{buildroot}/%{_datadir}/icons/hicolor/${s}x$s/apps/tigervnc.png
done
popd

mkdir %{buildroot}/%{_datadir}/applications
desktop-file-install \
        --dir %{buildroot}%{_datadir}/applications \
        %{SOURCE6}

%find_lang %{name} %{name}.lang

# remove unwanted files
rm -f  %{buildroot}/%{_libdir}/xorg/modules/extensions/libvnc.la

# Install Java applet

install -d -m 755 %{buildroot}%{_javadir}
install -d -m 755 %{buildroot}%{_datadir}/vnc/classes
pushd java/build

install -m 755 VncViewer.jar %{buildroot}%{_datadir}/vnc/classes/vncviewer-%{version}.jar
popd

pushd java
install -m 644 com/tigervnc/vncviewer/index.vnc %{buildroot}%{_datadir}/vnc/classes
popd

pushd %{buildroot}%{_datadir}/vnc/classes
mv vncviewer-%{version}.jar %{buildroot}%{_javadir}
ln -s %{_javadir}/vncviewer-%{version}.jar VncViewer.jar
popd

pushd %{buildroot}%{_javadir}
ln -s vncviewer-%{version}.jar vncviewer.jar
ln -s vncviewer-%{version}.jar VncViewer.jar
popd




%changelog
* Wed Apr 02 2014 bersuit <bersuit> 1.3.0-2.1.mga4
+ Revision: 611380
- Fixed heap-based buffer overflow (CVE-2014-0011, #mga13082)

* Tue Oct 22 2013 umeabot <umeabot> 1.3.0-2.mga4
+ Revision: 542337
- Mageia 4 Mass Rebuild

* Wed Oct 09 2013 bersuit <bersuit> 1.3.0-1.mga4
+ Revision: 494273
- Update to new upstream version 1.3.0
-Synchronized with fedora.
-Add Fedora bug-fixing patch
-Add OpenMandriva build patch
-fix #mga10181: changes the java classes path /usr/share/tigervnc/classes to /usr/share/vnc/classes
-Rebuilt xorg110 & xorg111 fedora patch
-Added fedora patch to xorg112 & xorg113
-Added fedora patch to latest Java 7

  + umeabot <umeabot>
    - Mass Rebuild - https://wiki.mageia.org/en/Feature:Mageia3MassRebuild

* Sun May 13 2012 pterjan <pterjan> 1.1.0-3.mga2
+ Revision: 235645
- Revert untested/incomplete/hard to use/breaking updates systemd integration to make package installable again (mga#4777)

* Sat Apr 28 2012 tmb <tmb> 1.1.0-2.mga2
+ Revision: 233875
- Require rpm-helper >= 0.24.8-1 for systemd support

  + fwang <fwang>
    - there is no workaround for ldflags

* Sat Dec 10 2011 dmorgan <dmorgan> 1.1.0-1.mga2
+ Revision: 180037
- Disable unit-tests
- New version 1.1.0

* Tue Sep 06 2011 dmorgan <dmorgan> 1.0.90-0.201106280527.2.mga2
+ Revision: 138995
- Add desktop-file-utils as buildRequire
- Add desktop-file-install as buildRequire

  + misc <misc>
    - do not hardcode the name of the distribution anymore
    - remove old obsoletes/provides

  + fwang <fwang>
    - new snapshot 20110628
    - build with xserver 1.10
    - rebuild for new gnutls

* Tue Feb 22 2011 dmorgan <dmorgan> 1.0.90-0.201012034210.6.mga1
+ Revision: 57070
- Remove Encoding from desktop file
- Fix bugzilla URL
- imported package tigervnc


* Thu Jan 13 2011 Paulo Ricardo Zanoni <pzanoni@mandriva.com> 1.0.90-0.201012034210.6mdv2011.0
+ Revision: 631010
- Obsolete RealVNC packages

* Tue Dec 28 2010 Paulo Ricardo Zanoni <pzanoni@mandriva.com> 1.0.90-0.201012034210.5mdv2011.0
+ Revision: 625668
- BR java-devel
- Add -java package
- Use %%makeinstall_std

* Thu Dec 23 2010 Paulo Ricardo Zanoni <pzanoni@mandriva.com> 1.0.90-0.201012034210.4mdv2011.0
+ Revision: 624170
- Remove sysconfig, initscript and require vnc-server-common
- Fix dekstop file categories
- Update summaries, descriptions, profiles, conflicts and groups (part of vnc
  packages standardization)

* Thu Dec 16 2010 Paulo Ricardo Zanoni <pzanoni@mandriva.com> 1.0.90-0.201012034210.3mdv2011.0
+ Revision: 622330
- Add patches to fix problems with scrollbars.

* Wed Dec 08 2010 Paulo Ricardo Zanoni <pzanoni@mandriva.com> 1.0.90-0.201012034210.2mdv2011.0
+ Revision: 616320
- Add initscript file
- Add sysconfig/vncservers file
- Use configure2_5x
- Use system jpeg
- Remove unrecognized configure options
- Don't chmod files copied by x11-server-source

* Mon Dec 06 2010 Paulo Ricardo Zanoni <pzanoni@mandriva.com> 1.0.90-0.201012034210.1mdv2011.0
+ Revision: 612395
- Update to newer revision
- Use xserver19 patch
- Fix linking

* Wed May 05 2010 Paulo Ricardo Zanoni <pzanoni@mandriva.com> 1.0.90-0.201004234031.2mdv2010.1
+ Revision: 542633
- Remove sed in Makefile.am (was breaking libvnc.so)
- Add URL tag

* Fri Apr 23 2010 Paulo Ricardo Zanoni <pzanoni@mandriva.com> 1.0.90-0.201004234031.1mdv2010.1
+ Revision: 538366
- import tigervnc

